//==============================================================
// Berserk Monsters Mutator by Mr.Loathsome. - v5.7 - 1/4/12
//==============================================================
class BM expands Mutator config(BerserkMonsters);

var() config float InsanityRate;
var() config int MaxChecks;
var() config bool bAdjustBosses;
var() config bool bAttackKin;
var() config bool bSeqCheck;
var() config bool bDebug;
var() config bool bExtDebug;
var() config string ExcludeClass;
var class<Actor> exClass;
var int HateRadius, SPOffset, PrevHR, HRcnt;
var bool bFastChk;

function PostBeginPlay()
{

	exClass = class<Actor>(DynamicLoadObject(ExcludeClass, class'Class'));
	HateRadius = 500; SPOffset = 0; bFastChk = True;
	log("BerserkMonsters Init --> InsanityRate: "$InsanityRate$"  MaxChecks: "$MaxChecks$"  bAdjustBosses: "$bAdjustBosses$"  bAttackKin: "$bAttackKin$"  bDebug: "$bDebug$"  bExtDebug: "$bExtDebug$"  ExcludeClass: "$ExcludeClass);
	SetTimer(InsanityRate, True);
	Super.PostBeginPlay();
}

function Timer()
{
	local ScriptedPawn SP;
	local Pawn aVictim, PrevEnemy;
	local int NumMonsters, NumChecked, NumAdjusted;

	NumMonsters = 0; NumChecked = 0; NumAdjusted = 0;
	foreach AllActors(class'ScriptedPawn', SP)
	{
	  NumMonsters++;
	  if ((bSeqCheck) || (NumMonsters > SPOffset))
	  {
		if ((bExtDebug) && (SP.Enemy != None) && (MaxChecks == 0)) { log("BerserkMonsters --> SP: "$SP$"  SP.Health: "$SP.Health$"  Current Enemy: "$SP.Enemy); }
		if ((!ClassIsChildOf(SP.class, exClass)) && (SP.Health > 0) && (MaxChecks > 0))
		{
			if ((SP.bIsBoss) && (!bAdjustBosses))
			{
				if (bExtDebug) { log("BerserkMonsters --> No boss adjusting... SP: "$SP); }
			}
			else
			{
				NumChecked++;
				PrevEnemy = SP.Enemy;
				foreach RadiusActors(class'Pawn', aVictim, HateRadius, SP.Location)
				{
					if (((aVictim.class == SP.class) && (!bAttackKin)) || (aVictim == PrevEnemy) || (!SP.LineOfSightTo(aVictim)) ||
						 (aVictim.IsA('FlockPawn')) || (aVictim.IsA('FlockMasterPawn')) || (aVictim.IsA('StationaryPawn')) ||
						 ((SP.Region.Zone.bWaterZone) && (!aVictim.Region.Zone.bWaterZone)) ||
						 ((aVictim.IsA('ScriptedPawn')) && (ScriptedPawn(aVictim).bIsBoss) && (!bAdjustBosses)))
					{  } // skip this victim
					else
					if ((aVictim != SP) && (aVictim.Health > 10))
					{
						if (bExtDebug) { log("BerserkMonsters --> SP: "$SP$"  SP.Health: "$SP.Health$"  aVictim: "$aVictim$"  aVictim.Health: "$aVictim.Health@"  PrevEnemy: "$PrevEnemy); }
						SP.bHateWhenTriggered=True;
						SP.Intelligence=BRAINS_Human;
						SP.CombatStyle = FMin((FRand()+0.250), 1.0);
						SP.Hated = aVictim;
						SP.Enemy = aVictim;
						if (SP.SetEnemy(aVictim)) { SP.gotostate('Attacking'); NumAdjusted++; break; }
					}
				}
				if (SP.Enemy == None) { SP.gotostate('Hunting'); }
				if ((bExtDebug) && (SP.Enemy == None)) { log("BerserkMonsters --> SP: "$SP$"  SP.Health: "$SP.Health$"  No victim in range...."); }
			}
		}
		if ((NumChecked >= MaxChecks) && (MaxChecks !=0)) { break; }
	  }
	}
	if (NumChecked > 1)
	{
		if (NumAdjusted < (NumChecked*0.5))
			{
				if (HateRadius < 18000) { HateRadius += ((HateRadius * 0.20) + NumAdjusted); }
			}
		else
			{ if (HateRadius > (HateRadius * 0.20) + 60) { HateRadius -= ((HateRadius * 0.20) + NumAdjusted); } }

	}
	if (!bSeqCheck)
	{
		SPOffset += NumChecked;
		if (NumChecked == 0) { SPOffset = 0; }
	}
	if (HateRadius == PrevHR)
	{
		HRcnt++; If (HRcnt > 32000) { HRcnt = 3; }
		if (HRcnt == 3) { SetTimer(InsanityRate * 4, True); if (bDebug) BroadcastMessage("BerserkMonsters --> Slow check enabled..."); Log("BerserkMonsters --> Slow check enabled...");bFastChk = False; }
		
	}
	else
	{
		if (!bFastChk)
		{
			SetTimer(InsanityRate * 0.25, True);
			if (bDebug) BroadcastMessage("BerserkMonsters --> Fast check enabled...");
			Log("BerserkMonsters --> Fast check enabled...");
			bFastChk = True;
		}
		HRcnt = 0;
	}
	PrevHR = HateRadius;
	if (bDebug)
	{
		if (MaxChecks != 0)
		{
			BroadcastMessage("BerserkMonsters --> #Adjustable: "$NumChecked@"  #Adjusted: "$NumAdjusted@"  SPOffset: "$SPOffset@"  Current HateRadius: "$HateRadius);
			log("BerserkMonsters --> #Adjustable: "$NumChecked@"  #Adjusted: "$NumAdjusted@"  SPOffset: "$SPOffset@"  Current HateRadius: "$HateRadius);
		}
		else
		{
			BroadcastMessage("Current Monster Count: "$NumMonsters);
			log("BerserkMonsters --> Current Monster Count: "$NumMonsters);
		}
	}
}

defaultproperties
{
     InsanityRate=20.0
     MaxChecks=32
     bAdjustBosses=False
     bAttackKin=True
     bSeqCheck=False
     bDebug=False
     bExtDebug=False
     ExcludeClass=
}
